#!/usr/bin/env python
# -*- encoding: utf-8 -*-
'''
@Contact :   liuyuqi.gov@msn.cn
@Time    :   2023/09/14 07:12:53
@License :   Copyright © 2017-2022 liuyuqi. All Rights Reserved.
@Desc    :   
'''

# check update from github
import os
import sys
import time
import requests
import json
import re
import subprocess

def checkUpdate()->str:
    ''' check update 
    return:
        False: no new version
        str: new version
    '''
    repo='jianboy/crawl_xiaohua'
    url='https://api.github.com/repos/%s/releases/latest' % repo
    try:
        res = requests.get(url)
        if res.status_code != 200:
            return False
        res = json.loads(res.text)
        tag_name = res['tag_name']
        if tag_name == 'v%s' % getVersion():
            return False
        return tag_name
    
    except Exception as e:
        print(e)
        return False

def getVersion():
    ''' get version from setup.py '''
    with open('setup.py', 'r') as f:
        content = f.read()
        res = re.search(r'version="(.*)"', content)
        if res:
            return res.group(1)
        else:
            return '0.0.0'

def update():
    ''' check update, if new version exist, download and update it, then restart app '''
    tag_name = checkUpdate()
    if tag_name:
        print('new version: %s' % tag_name)
        print('updating...')
        cmd = 'pip install --upgrade git+'
        cmd += tag_name
        cmd += '#egg=crawl_xiaohua'
        print(cmd)
        os.system(cmd)
        print('update success, restart app...')
        os.system('python -m crawl_xiaohua')
        sys.exit(0)
    else:
        print('no new version')
        sys.exit(0)